/* rygel-mpris-player.c generated by valac 0.10.0, the Vala compiler
 * generated from rygel-mpris-player.vala, do not modify */

/*
 * Copyright (C) 2008 OpenedHand Ltd.
 * Copyright (C) 2009 Nokia Corporation.
 *
 * Author: Jorn Baayen <jorn@openedhand.com>
 *         Zeeshan Ali (Khattak) <zeeshanak@gnome.org>
 *                               <zeeshan.ali@nokia.com>
 *
 * Rygel is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Rygel is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 */

#include <glib.h>
#include <glib-object.h>
#include <rygel.h>
#include <stdlib.h>
#include <string.h>
#include <dbus/dbus-glib-lowlevel.h>
#include <dbus/dbus-glib.h>
#include <float.h>
#include <math.h>
#include <gst/gst.h>


#define RYGEL_MPRIS_TYPE_PLAYER (rygel_mpris_player_get_type ())
#define RYGEL_MPRIS_PLAYER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), RYGEL_MPRIS_TYPE_PLAYER, RygelMPRISPlayer))
#define RYGEL_MPRIS_PLAYER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), RYGEL_MPRIS_TYPE_PLAYER, RygelMPRISPlayerClass))
#define RYGEL_MPRIS_IS_PLAYER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), RYGEL_MPRIS_TYPE_PLAYER))
#define RYGEL_MPRIS_IS_PLAYER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), RYGEL_MPRIS_TYPE_PLAYER))
#define RYGEL_MPRIS_PLAYER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), RYGEL_MPRIS_TYPE_PLAYER, RygelMPRISPlayerClass))

typedef struct _RygelMPRISPlayer RygelMPRISPlayer;
typedef struct _RygelMPRISPlayerClass RygelMPRISPlayerClass;
typedef struct _RygelMPRISPlayerPrivate RygelMPRISPlayerPrivate;

#define RYGEL_MPRIS_MEDIA_PLAYER_TYPE_PLAYER_PROXY (rygel_mpris_media_player_player_proxy_get_type ())
#define RYGEL_MPRIS_MEDIA_PLAYER_PLAYER_PROXY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), RYGEL_MPRIS_MEDIA_PLAYER_TYPE_PLAYER_PROXY, RygelMPRISMediaPlayerPlayerProxy))
#define RYGEL_MPRIS_MEDIA_PLAYER_IS_PLAYER_PROXY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), RYGEL_MPRIS_MEDIA_PLAYER_TYPE_PLAYER_PROXY))
#define RYGEL_MPRIS_MEDIA_PLAYER_PLAYER_PROXY_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), RYGEL_MPRIS_MEDIA_PLAYER_TYPE_PLAYER_PROXY, RygelMPRISMediaPlayerPlayerProxyIface))

typedef struct _RygelMPRISMediaPlayerPlayerProxy RygelMPRISMediaPlayerPlayerProxy;
typedef struct _RygelMPRISMediaPlayerPlayerProxyIface RygelMPRISMediaPlayerPlayerProxyIface;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define __vala_GValue_free0(var) ((var == NULL) ? NULL : (var = (_vala_GValue_free (var), NULL)))

struct _RygelMPRISPlayer {
	GObject parent_instance;
	RygelMPRISPlayerPrivate * priv;
};

struct _RygelMPRISPlayerClass {
	GObjectClass parent_class;
};

struct _RygelMPRISMediaPlayerPlayerProxyIface {
	GTypeInterface parent_iface;
	void (*pause) (RygelMPRISMediaPlayerPlayerProxy* self, GError** error);
	void (*play_pause) (RygelMPRISMediaPlayerPlayerProxy* self, GError** error);
	void (*stop) (RygelMPRISMediaPlayerPlayerProxy* self, GError** error);
	void (*play) (RygelMPRISMediaPlayerPlayerProxy* self, GError** error);
	void (*seek) (RygelMPRISMediaPlayerPlayerProxy* self, gint64 offset, GError** error);
	void (*open_uri) (RygelMPRISMediaPlayerPlayerProxy* self, const char* uri, GError** error);
	char* (*get_playback_status) (RygelMPRISMediaPlayerPlayerProxy* self);
	double (*get_volume) (RygelMPRISMediaPlayerPlayerProxy* self);
	void (*set_volume) (RygelMPRISMediaPlayerPlayerProxy* self, double value);
	gint64 (*get_position) (RygelMPRISMediaPlayerPlayerProxy* self);
	GHashTable* (*get_metadata) (RygelMPRISMediaPlayerPlayerProxy* self);
};

struct _RygelMPRISPlayerPrivate {
	char** protocols;
	gint protocols_length1;
	gint _protocols_size_;
	char** mime_types;
	gint mime_types_length1;
	gint _mime_types_size_;
	RygelMPRISMediaPlayerPlayerProxy* actual_player;
	FreeDesktopProperties* properties;
};


static gpointer rygel_mpris_player_parent_class = NULL;
static RygelMediaPlayerIface* rygel_mpris_player_rygel_media_player_parent_iface = NULL;

GType rygel_mpris_player_get_type (void) G_GNUC_CONST;
RygelMPRISMediaPlayerPlayerProxy* rygel_mpris_media_player_player_proxy_dbus_proxy_new (DBusGConnection* connection, const char* name, const char* path);
GType rygel_mpris_media_player_player_proxy_get_type (void) G_GNUC_CONST;
#define RYGEL_MPRIS_PLAYER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), RYGEL_MPRIS_TYPE_PLAYER, RygelMPRISPlayerPrivate))
enum  {
	RYGEL_MPRIS_PLAYER_DUMMY_PROPERTY,
	RYGEL_MPRIS_PLAYER_PLAYBACK_STATE,
	RYGEL_MPRIS_PLAYER_URI,
	RYGEL_MPRIS_PLAYER_VOLUME,
	RYGEL_MPRIS_PLAYER_DURATION,
	RYGEL_MPRIS_PLAYER_POSITION
};
RygelMPRISPlayer* rygel_mpris_player_new (RygelMPRISMediaPlayerPlayerProxy* actual_player, FreeDesktopProperties* properties, char** mime_types, int mime_types_length1, char** protocols, int protocols_length1);
RygelMPRISPlayer* rygel_mpris_player_construct (GType object_type, RygelMPRISMediaPlayerPlayerProxy* actual_player, FreeDesktopProperties* properties, char** mime_types, int mime_types_length1, char** protocols, int protocols_length1);
static char** _vala_array_dup1 (char** self, int length);
static char** _vala_array_dup2 (char** self, int length);
static void rygel_mpris_player_on_properties_changed (RygelMPRISPlayer* self, const char* iface, GHashTable* changed, char** invalidated, int invalidated_length1);
static void _rygel_mpris_player_on_properties_changed_free_desktop_properties_properties_changed (FreeDesktopProperties* _sender, const char* iface, GHashTable* changed, char** invalidated, int invalidated_length1, gpointer self);
static gboolean rygel_mpris_player_real_seek (RygelMediaPlayer* base, GstClockTime time);
void rygel_mpris_media_player_player_proxy_seek (RygelMPRISMediaPlayerPlayerProxy* self, gint64 offset, GError** error);
static char** rygel_mpris_player_real_get_protocols (RygelMediaPlayer* base, int* result_length1);
static char** _vala_array_dup3 (char** self, int length);
static char** rygel_mpris_player_real_get_mime_types (RygelMediaPlayer* base, int* result_length1);
static char** _vala_array_dup4 (char** self, int length);
static char* rygel_mpris_player_mpris_to_upnp_state (RygelMPRISPlayer* self, const char* state);
GHashTable* rygel_mpris_media_player_player_proxy_get_metadata (RygelMPRISMediaPlayerPlayerProxy* self);
char* rygel_mpris_media_player_player_proxy_get_playback_status (RygelMPRISMediaPlayerPlayerProxy* self);
void rygel_mpris_media_player_player_proxy_stop (RygelMPRISMediaPlayerPlayerProxy* self, GError** error);
void rygel_mpris_media_player_player_proxy_pause (RygelMPRISMediaPlayerPlayerProxy* self, GError** error);
void rygel_mpris_media_player_player_proxy_play (RygelMPRISMediaPlayerPlayerProxy* self, GError** error);
static GValue* _g_value_dup (GValue* self);
static void _vala_GValue_free (GValue* self);
void rygel_mpris_media_player_player_proxy_open_uri (RygelMPRISMediaPlayerPlayerProxy* self, const char* uri, GError** error);
double rygel_mpris_media_player_player_proxy_get_volume (RygelMPRISMediaPlayerPlayerProxy* self);
void rygel_mpris_media_player_player_proxy_set_volume (RygelMPRISMediaPlayerPlayerProxy* self, double value);
gint64 rygel_mpris_media_player_player_proxy_get_position (RygelMPRISMediaPlayerPlayerProxy* self);
static void rygel_mpris_player_finalize (GObject* obj);
static void rygel_mpris_player_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void rygel_mpris_player_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);



static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static char** _vala_array_dup1 (char** self, int length) {
	char** result;
	int i;
	result = g_new0 (char*, length + 1);
	for (i = 0; i < length; i++) {
		result[i] = g_strdup (self[i]);
	}
	return result;
}


static char** _vala_array_dup2 (char** self, int length) {
	char** result;
	int i;
	result = g_new0 (char*, length + 1);
	for (i = 0; i < length; i++) {
		result[i] = g_strdup (self[i]);
	}
	return result;
}


#line 160 "rygel-mpris-player.vala"
static void _rygel_mpris_player_on_properties_changed_free_desktop_properties_properties_changed (FreeDesktopProperties* _sender, const char* iface, GHashTable* changed, char** invalidated, int invalidated_length1, gpointer self) {
#line 176 "rygel-mpris-player.c"
	rygel_mpris_player_on_properties_changed (self, iface, changed, invalidated, invalidated_length1);
}


#line 116 "rygel-mpris-player.vala"
RygelMPRISPlayer* rygel_mpris_player_construct (GType object_type, RygelMPRISMediaPlayerPlayerProxy* actual_player, FreeDesktopProperties* properties, char** mime_types, int mime_types_length1, char** protocols, int protocols_length1) {
#line 183 "rygel-mpris-player.c"
	RygelMPRISPlayer * self;
	RygelMPRISMediaPlayerPlayerProxy* _tmp0_;
	FreeDesktopProperties* _tmp1_;
	char** _tmp2_;
	char** _tmp3_;
	char** _tmp4_;
	char** _tmp5_;
#line 116 "rygel-mpris-player.vala"
	g_return_val_if_fail (actual_player != NULL, NULL);
#line 116 "rygel-mpris-player.vala"
	g_return_val_if_fail (properties != NULL, NULL);
#line 116 "rygel-mpris-player.vala"
	self = (RygelMPRISPlayer*) g_object_new (object_type, NULL);
#line 120 "rygel-mpris-player.vala"
	self->priv->actual_player = (_tmp0_ = _g_object_ref0 (actual_player), _g_object_unref0 (self->priv->actual_player), _tmp0_);
#line 121 "rygel-mpris-player.vala"
	self->priv->properties = (_tmp1_ = _g_object_ref0 (properties), _g_object_unref0 (self->priv->properties), _tmp1_);
#line 122 "rygel-mpris-player.vala"
	self->priv->mime_types = (_tmp3_ = (_tmp2_ = mime_types, (_tmp2_ == NULL) ? ((gpointer) _tmp2_) : _vala_array_dup1 (_tmp2_, mime_types_length1)), self->priv->mime_types = (_vala_array_free (self->priv->mime_types, self->priv->mime_types_length1, (GDestroyNotify) g_free), NULL), self->priv->mime_types_length1 = mime_types_length1, self->priv->_mime_types_size_ = self->priv->mime_types_length1, _tmp3_);
#line 123 "rygel-mpris-player.vala"
	self->priv->protocols = (_tmp5_ = (_tmp4_ = protocols, (_tmp4_ == NULL) ? ((gpointer) _tmp4_) : _vala_array_dup2 (_tmp4_, protocols_length1)), self->priv->protocols = (_vala_array_free (self->priv->protocols, self->priv->protocols_length1, (GDestroyNotify) g_free), NULL), self->priv->protocols_length1 = protocols_length1, self->priv->_protocols_size_ = self->priv->protocols_length1, _tmp5_);
#line 125 "rygel-mpris-player.vala"
	g_signal_connect_object (self->priv->properties, "properties-changed", (GCallback) _rygel_mpris_player_on_properties_changed_free_desktop_properties_properties_changed, self, 0);
#line 207 "rygel-mpris-player.c"
	return self;
}


#line 116 "rygel-mpris-player.vala"
RygelMPRISPlayer* rygel_mpris_player_new (RygelMPRISMediaPlayerPlayerProxy* actual_player, FreeDesktopProperties* properties, char** mime_types, int mime_types_length1, char** protocols, int protocols_length1) {
#line 116 "rygel-mpris-player.vala"
	return rygel_mpris_player_construct (RYGEL_MPRIS_TYPE_PLAYER, actual_player, properties, mime_types, mime_types_length1, protocols, protocols_length1);
#line 216 "rygel-mpris-player.c"
}


#line 128 "rygel-mpris-player.vala"
static gboolean rygel_mpris_player_real_seek (RygelMediaPlayer* base, GstClockTime time) {
#line 222 "rygel-mpris-player.c"
	RygelMPRISPlayer * self;
	gboolean result = FALSE;
	gboolean ret;
	GError * _inner_error_ = NULL;
	self = (RygelMPRISPlayer*) base;
#line 129 "rygel-mpris-player.vala"
	ret = FALSE;
#line 230 "rygel-mpris-player.c"
	{
#line 132 "rygel-mpris-player.vala"
		rygel_mpris_media_player_player_proxy_seek (self->priv->actual_player, (gint64) (time / 1000), &_inner_error_);
#line 234 "rygel-mpris-player.c"
		if (_inner_error_ != NULL) {
			goto __catch0_g_error;
		}
#line 133 "rygel-mpris-player.vala"
		ret = TRUE;
#line 240 "rygel-mpris-player.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError * _error_;
		_error_ = _inner_error_;
		_inner_error_ = NULL;
		{
			_g_error_free0 (_error_);
		}
	}
	__finally0:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return FALSE;
	}
	result = ret;
#line 136 "rygel-mpris-player.vala"
	return result;
#line 261 "rygel-mpris-player.c"
}


static char** _vala_array_dup3 (char** self, int length) {
	char** result;
	int i;
	result = g_new0 (char*, length + 1);
	for (i = 0; i < length; i++) {
		result[i] = g_strdup (self[i]);
	}
	return result;
}


#line 139 "rygel-mpris-player.vala"
static char** rygel_mpris_player_real_get_protocols (RygelMediaPlayer* base, int* result_length1) {
#line 278 "rygel-mpris-player.c"
	RygelMPRISPlayer * self;
	char** result = NULL;
	char** _tmp0_;
	char** _tmp1_;
	self = (RygelMPRISPlayer*) base;
	result = (_tmp1_ = (_tmp0_ = self->priv->protocols, (_tmp0_ == NULL) ? ((gpointer) _tmp0_) : _vala_array_dup3 (_tmp0_, self->priv->protocols_length1)), *result_length1 = self->priv->protocols_length1, _tmp1_);
#line 140 "rygel-mpris-player.vala"
	return result;
#line 287 "rygel-mpris-player.c"
}


static char** _vala_array_dup4 (char** self, int length) {
	char** result;
	int i;
	result = g_new0 (char*, length + 1);
	for (i = 0; i < length; i++) {
		result[i] = g_strdup (self[i]);
	}
	return result;
}


#line 143 "rygel-mpris-player.vala"
static char** rygel_mpris_player_real_get_mime_types (RygelMediaPlayer* base, int* result_length1) {
#line 304 "rygel-mpris-player.c"
	RygelMPRISPlayer * self;
	char** result = NULL;
	char** _tmp0_;
	char** _tmp1_;
	self = (RygelMPRISPlayer*) base;
	result = (_tmp1_ = (_tmp0_ = self->priv->mime_types, (_tmp0_ == NULL) ? ((gpointer) _tmp0_) : _vala_array_dup4 (_tmp0_, self->priv->mime_types_length1)), *result_length1 = self->priv->mime_types_length1, _tmp1_);
#line 144 "rygel-mpris-player.vala"
	return result;
#line 313 "rygel-mpris-player.c"
}


#line 147 "rygel-mpris-player.vala"
static char* rygel_mpris_player_mpris_to_upnp_state (RygelMPRISPlayer* self, const char* state) {
#line 319 "rygel-mpris-player.c"
	char* result = NULL;
	const char* _tmp0_;
	GQuark _tmp1_;
	static GQuark _tmp1__label0 = 0;
	static GQuark _tmp1__label1 = 0;
	static GQuark _tmp1__label2 = 0;
#line 147 "rygel-mpris-player.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 147 "rygel-mpris-player.vala"
	g_return_val_if_fail (state != NULL, NULL);
#line 330 "rygel-mpris-player.c"
	_tmp0_ = state;
	_tmp1_ = (NULL == _tmp0_) ? 0 : g_quark_from_string (_tmp0_);
	if (_tmp1_ == ((0 != _tmp1__label0) ? _tmp1__label0 : (_tmp1__label0 = g_quark_from_static_string ("Stopped"))))
	switch (0) {
		default:
		{
			result = g_strdup ("STOPPED");
#line 150 "rygel-mpris-player.vala"
			return result;
#line 340 "rygel-mpris-player.c"
		}
	} else if (_tmp1_ == ((0 != _tmp1__label1) ? _tmp1__label1 : (_tmp1__label1 = g_quark_from_static_string ("Paused"))))
	switch (0) {
		default:
		{
			result = g_strdup ("PAUSED_PLAYBACK");
#line 152 "rygel-mpris-player.vala"
			return result;
#line 349 "rygel-mpris-player.c"
		}
	} else if (_tmp1_ == ((0 != _tmp1__label2) ? _tmp1__label2 : (_tmp1__label2 = g_quark_from_static_string ("Playing"))))
	switch (0) {
		default:
		{
			result = g_strdup ("PLAYING");
#line 154 "rygel-mpris-player.vala"
			return result;
#line 358 "rygel-mpris-player.c"
		}
	} else
	switch (0) {
		default:
		{
#line 156 "rygel-mpris-player.vala"
			g_assert_not_reached ();
#line 366 "rygel-mpris-player.c"
		}
	}
}


#line 160 "rygel-mpris-player.vala"
static void rygel_mpris_player_on_properties_changed (RygelMPRISPlayer* self, const char* iface, GHashTable* changed, char** invalidated, int invalidated_length1) {
#line 160 "rygel-mpris-player.vala"
	g_return_if_fail (self != NULL);
#line 160 "rygel-mpris-player.vala"
	g_return_if_fail (iface != NULL);
#line 160 "rygel-mpris-player.vala"
	g_return_if_fail (changed != NULL);
#line 163 "rygel-mpris-player.vala"
	if (((GValue*) g_hash_table_lookup (changed, "PlaybackStatus")) != NULL) {
#line 164 "rygel-mpris-player.vala"
		g_object_notify ((GObject*) self, "playback-state");
#line 384 "rygel-mpris-player.c"
	}
#line 167 "rygel-mpris-player.vala"
	if (((GValue*) g_hash_table_lookup (changed, "Volume")) != NULL) {
#line 168 "rygel-mpris-player.vala"
		g_object_notify ((GObject*) self, "volume");
#line 390 "rygel-mpris-player.c"
	}
#line 171 "rygel-mpris-player.vala"
	if (((GValue*) g_hash_table_lookup (changed, "Metadata")) != NULL) {
#line 394 "rygel-mpris-player.c"
		GHashTable* metadata;
#line 172 "rygel-mpris-player.vala"
		metadata = rygel_mpris_media_player_player_proxy_get_metadata (self->priv->actual_player);
#line 174 "rygel-mpris-player.vala"
		if (((GValue*) g_hash_table_lookup (metadata, "xesam:url")) != NULL) {
#line 175 "rygel-mpris-player.vala"
			g_object_notify ((GObject*) self, "uri");
#line 402 "rygel-mpris-player.c"
		}
#line 178 "rygel-mpris-player.vala"
		if (((GValue*) g_hash_table_lookup (metadata, "mpris:length")) != NULL) {
#line 179 "rygel-mpris-player.vala"
			g_object_notify ((GObject*) self, "duration");
#line 408 "rygel-mpris-player.c"
		}
		_g_hash_table_unref0 (metadata);
	}
}


static char* rygel_mpris_player_real_get_playback_state (RygelMediaPlayer* base) {
	char* result;
	RygelMPRISPlayer* self;
	char* _tmp0_;
	char* _tmp1_;
	self = (RygelMPRISPlayer*) base;
	result = (_tmp1_ = rygel_mpris_player_mpris_to_upnp_state (self, _tmp0_ = rygel_mpris_media_player_player_proxy_get_playback_status (self->priv->actual_player)), _g_free0 (_tmp0_), _tmp1_);
#line 37 "rygel-mpris-player.vala"
	return result;
#line 424 "rygel-mpris-player.c"
}


static void rygel_mpris_player_real_set_playback_state (RygelMediaPlayer* base, const char* value) {
	RygelMPRISPlayer* self;
	const char* _tmp0_;
	GQuark _tmp1_;
	static GQuark _tmp1__label0 = 0;
	static GQuark _tmp1__label1 = 0;
	static GQuark _tmp1__label2 = 0;
	GError * _inner_error_ = NULL;
	self = (RygelMPRISPlayer*) base;
#line 41 "rygel-mpris-player.vala"
	g_debug ("rygel-mpris-player.vala:41: Changing playback state to %s..", value);
#line 439 "rygel-mpris-player.c"
	_tmp0_ = value;
	_tmp1_ = (NULL == _tmp0_) ? 0 : g_quark_from_string (_tmp0_);
	if (_tmp1_ == ((0 != _tmp1__label0) ? _tmp1__label0 : (_tmp1__label0 = g_quark_from_static_string ("STOPPED"))))
	switch (0) {
		default:
		{
			{
#line 47 "rygel-mpris-player.vala"
				rygel_mpris_media_player_player_proxy_stop (self->priv->actual_player, &_inner_error_);
#line 449 "rygel-mpris-player.c"
				if (_inner_error_ != NULL) {
					goto __catch1_g_error;
				}
			}
			goto __finally1;
			__catch1_g_error:
			{
				GError * _error_;
				_error_ = _inner_error_;
				_inner_error_ = NULL;
				{
					_g_error_free0 (_error_);
				}
			}
			__finally1:
			if (_inner_error_ != NULL) {
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return;
			}
#line 50 "rygel-mpris-player.vala"
			break;
#line 472 "rygel-mpris-player.c"
		}
	} else if (_tmp1_ == ((0 != _tmp1__label1) ? _tmp1__label1 : (_tmp1__label1 = g_quark_from_static_string ("PAUSED_PLAYBACK"))))
	switch (0) {
		default:
		{
			{
#line 53 "rygel-mpris-player.vala"
				rygel_mpris_media_player_player_proxy_pause (self->priv->actual_player, &_inner_error_);
#line 481 "rygel-mpris-player.c"
				if (_inner_error_ != NULL) {
					goto __catch2_g_error;
				}
			}
			goto __finally2;
			__catch2_g_error:
			{
				GError * _error_;
				_error_ = _inner_error_;
				_inner_error_ = NULL;
				{
					_g_error_free0 (_error_);
				}
			}
			__finally2:
			if (_inner_error_ != NULL) {
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return;
			}
#line 56 "rygel-mpris-player.vala"
			break;
#line 504 "rygel-mpris-player.c"
		}
	} else if (_tmp1_ == ((0 != _tmp1__label2) ? _tmp1__label2 : (_tmp1__label2 = g_quark_from_static_string ("PLAYING"))))
	switch (0) {
		default:
		{
			{
#line 59 "rygel-mpris-player.vala"
				rygel_mpris_media_player_player_proxy_play (self->priv->actual_player, &_inner_error_);
#line 513 "rygel-mpris-player.c"
				if (_inner_error_ != NULL) {
					goto __catch3_g_error;
				}
			}
			goto __finally3;
			__catch3_g_error:
			{
				GError * _error_;
				_error_ = _inner_error_;
				_inner_error_ = NULL;
				{
					_g_error_free0 (_error_);
				}
			}
			__finally3:
			if (_inner_error_ != NULL) {
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return;
			}
#line 62 "rygel-mpris-player.vala"
			break;
#line 536 "rygel-mpris-player.c"
		}
	} else
	switch (0) {
		default:
		{
#line 64 "rygel-mpris-player.vala"
			g_assert_not_reached ();
#line 544 "rygel-mpris-player.c"
		}
	}
	g_object_notify ((GObject *) self, "playback-state");
}


static GValue* _g_value_dup (GValue* self) {
	return g_boxed_copy (G_TYPE_VALUE, self);
}


static gpointer __g_value_dup0 (gpointer self) {
	return self ? _g_value_dup (self) : NULL;
}


static void _vala_GValue_free (GValue* self) {
	g_value_unset (self);
	g_free (self);
}


static char* rygel_mpris_player_real_get_uri (RygelMediaPlayer* base) {
	char* result;
	RygelMPRISPlayer* self;
	GHashTable* _tmp0_;
	GValue* _tmp1_;
	GValue* val;
	self = (RygelMPRISPlayer*) base;
#line 71 "rygel-mpris-player.vala"
	val = (_tmp1_ = __g_value_dup0 ((GValue*) g_hash_table_lookup (_tmp0_ = rygel_mpris_media_player_player_proxy_get_metadata (self->priv->actual_player), "xesam:url")), _g_hash_table_unref0 (_tmp0_), _tmp1_);
#line 73 "rygel-mpris-player.vala"
	if (val != NULL) {
#line 578 "rygel-mpris-player.c"
		result = g_strdup (g_value_get_string (val));
		__vala_GValue_free0 (val);
#line 74 "rygel-mpris-player.vala"
		return result;
#line 583 "rygel-mpris-player.c"
	} else {
		result = NULL;
		__vala_GValue_free0 (val);
#line 76 "rygel-mpris-player.vala"
		return result;
#line 589 "rygel-mpris-player.c"
	}
	__vala_GValue_free0 (val);
}


static void rygel_mpris_player_real_set_uri (RygelMediaPlayer* base, const char* value) {
	RygelMPRISPlayer* self;
	GError * _inner_error_ = NULL;
	self = (RygelMPRISPlayer*) base;
	{
#line 82 "rygel-mpris-player.vala"
		rygel_mpris_media_player_player_proxy_open_uri (self->priv->actual_player, value, &_inner_error_);
#line 602 "rygel-mpris-player.c"
		if (_inner_error_ != NULL) {
			goto __catch4_g_error;
		}
	}
	goto __finally4;
	__catch4_g_error:
	{
		GError * _error_;
		_error_ = _inner_error_;
		_inner_error_ = NULL;
		{
			_g_error_free0 (_error_);
		}
	}
	__finally4:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	g_object_notify ((GObject *) self, "uri");
}


static double rygel_mpris_player_real_get_volume (RygelMediaPlayer* base) {
	double result;
	RygelMPRISPlayer* self;
	self = (RygelMPRISPlayer*) base;
	result = rygel_mpris_media_player_player_proxy_get_volume (self->priv->actual_player);
#line 89 "rygel-mpris-player.vala"
	return result;
#line 634 "rygel-mpris-player.c"
}


static void rygel_mpris_player_real_set_volume (RygelMediaPlayer* base, double value) {
	RygelMPRISPlayer* self;
	self = (RygelMPRISPlayer*) base;
#line 93 "rygel-mpris-player.vala"
	rygel_mpris_media_player_player_proxy_set_volume (self->priv->actual_player, value);
#line 643 "rygel-mpris-player.c"
	g_object_notify ((GObject *) self, "volume");
}


static gint64 rygel_mpris_player_real_get_duration (RygelMediaPlayer* base) {
	gint64 result;
	RygelMPRISPlayer* self;
	GHashTable* _tmp0_;
	GValue* _tmp1_;
	GValue* val;
	gint64 dur;
	self = (RygelMPRISPlayer*) base;
#line 99 "rygel-mpris-player.vala"
	val = (_tmp1_ = __g_value_dup0 ((GValue*) g_hash_table_lookup (_tmp0_ = rygel_mpris_media_player_player_proxy_get_metadata (self->priv->actual_player), "mpris:length")), _g_hash_table_unref0 (_tmp0_), _tmp1_);
#line 100 "rygel-mpris-player.vala"
	dur = (gint64) 0;
#line 102 "rygel-mpris-player.vala"
	if (val != NULL) {
#line 103 "rygel-mpris-player.vala"
		dur = g_value_get_int64 (val) * 1000;
#line 664 "rygel-mpris-player.c"
	}
	result = dur;
	__vala_GValue_free0 (val);
#line 106 "rygel-mpris-player.vala"
	return result;
#line 670 "rygel-mpris-player.c"
}


static gint64 rygel_mpris_player_real_get_position (RygelMediaPlayer* base) {
	gint64 result;
	RygelMPRISPlayer* self;
	self = (RygelMPRISPlayer*) base;
	result = rygel_mpris_media_player_player_proxy_get_position (self->priv->actual_player) * 1000;
#line 112 "rygel-mpris-player.vala"
	return result;
#line 681 "rygel-mpris-player.c"
}


static void rygel_mpris_player_class_init (RygelMPRISPlayerClass * klass) {
	rygel_mpris_player_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (RygelMPRISPlayerPrivate));
	G_OBJECT_CLASS (klass)->get_property = rygel_mpris_player_get_property;
	G_OBJECT_CLASS (klass)->set_property = rygel_mpris_player_set_property;
	G_OBJECT_CLASS (klass)->finalize = rygel_mpris_player_finalize;
	g_object_class_override_property (G_OBJECT_CLASS (klass), RYGEL_MPRIS_PLAYER_PLAYBACK_STATE, "playback-state");
	g_object_class_override_property (G_OBJECT_CLASS (klass), RYGEL_MPRIS_PLAYER_URI, "uri");
	g_object_class_override_property (G_OBJECT_CLASS (klass), RYGEL_MPRIS_PLAYER_VOLUME, "volume");
	g_object_class_override_property (G_OBJECT_CLASS (klass), RYGEL_MPRIS_PLAYER_DURATION, "duration");
	g_object_class_override_property (G_OBJECT_CLASS (klass), RYGEL_MPRIS_PLAYER_POSITION, "position");
}


static void rygel_mpris_player_rygel_media_player_interface_init (RygelMediaPlayerIface * iface) {
	rygel_mpris_player_rygel_media_player_parent_iface = g_type_interface_peek_parent (iface);
	iface->seek = rygel_mpris_player_real_seek;
	iface->get_protocols = rygel_mpris_player_real_get_protocols;
	iface->get_mime_types = rygel_mpris_player_real_get_mime_types;
	iface->get_playback_state = rygel_mpris_player_real_get_playback_state;
	iface->set_playback_state = rygel_mpris_player_real_set_playback_state;
	iface->get_uri = rygel_mpris_player_real_get_uri;
	iface->set_uri = rygel_mpris_player_real_set_uri;
	iface->get_volume = rygel_mpris_player_real_get_volume;
	iface->set_volume = rygel_mpris_player_real_set_volume;
	iface->get_duration = rygel_mpris_player_real_get_duration;
	iface->get_position = rygel_mpris_player_real_get_position;
}


static void rygel_mpris_player_instance_init (RygelMPRISPlayer * self) {
	self->priv = RYGEL_MPRIS_PLAYER_GET_PRIVATE (self);
}


static void rygel_mpris_player_finalize (GObject* obj) {
	RygelMPRISPlayer * self;
	self = RYGEL_MPRIS_PLAYER (obj);
	self->priv->protocols = (_vala_array_free (self->priv->protocols, self->priv->protocols_length1, (GDestroyNotify) g_free), NULL);
	self->priv->mime_types = (_vala_array_free (self->priv->mime_types, self->priv->mime_types_length1, (GDestroyNotify) g_free), NULL);
	_g_object_unref0 (self->priv->actual_player);
	_g_object_unref0 (self->priv->properties);
	G_OBJECT_CLASS (rygel_mpris_player_parent_class)->finalize (obj);
}


GType rygel_mpris_player_get_type (void) {
	static volatile gsize rygel_mpris_player_type_id__volatile = 0;
	if (g_once_init_enter (&rygel_mpris_player_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (RygelMPRISPlayerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) rygel_mpris_player_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (RygelMPRISPlayer), 0, (GInstanceInitFunc) rygel_mpris_player_instance_init, NULL };
		static const GInterfaceInfo rygel_media_player_info = { (GInterfaceInitFunc) rygel_mpris_player_rygel_media_player_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType rygel_mpris_player_type_id;
		rygel_mpris_player_type_id = g_type_register_static (G_TYPE_OBJECT, "RygelMPRISPlayer", &g_define_type_info, 0);
		g_type_add_interface_static (rygel_mpris_player_type_id, RYGEL_TYPE_MEDIA_PLAYER, &rygel_media_player_info);
		g_once_init_leave (&rygel_mpris_player_type_id__volatile, rygel_mpris_player_type_id);
	}
	return rygel_mpris_player_type_id__volatile;
}


static void rygel_mpris_player_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	RygelMPRISPlayer * self;
	self = RYGEL_MPRIS_PLAYER (object);
	switch (property_id) {
		case RYGEL_MPRIS_PLAYER_PLAYBACK_STATE:
		g_value_take_string (value, rygel_media_player_get_playback_state ((RygelMediaPlayer*) self));
		break;
		case RYGEL_MPRIS_PLAYER_URI:
		g_value_take_string (value, rygel_media_player_get_uri ((RygelMediaPlayer*) self));
		break;
		case RYGEL_MPRIS_PLAYER_VOLUME:
		g_value_set_double (value, rygel_media_player_get_volume ((RygelMediaPlayer*) self));
		break;
		case RYGEL_MPRIS_PLAYER_DURATION:
		g_value_set_int64 (value, rygel_media_player_get_duration ((RygelMediaPlayer*) self));
		break;
		case RYGEL_MPRIS_PLAYER_POSITION:
		g_value_set_int64 (value, rygel_media_player_get_position ((RygelMediaPlayer*) self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void rygel_mpris_player_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	RygelMPRISPlayer * self;
	self = RYGEL_MPRIS_PLAYER (object);
	switch (property_id) {
		case RYGEL_MPRIS_PLAYER_PLAYBACK_STATE:
		rygel_media_player_set_playback_state ((RygelMediaPlayer*) self, g_value_get_string (value));
		break;
		case RYGEL_MPRIS_PLAYER_URI:
		rygel_media_player_set_uri ((RygelMediaPlayer*) self, g_value_get_string (value));
		break;
		case RYGEL_MPRIS_PLAYER_VOLUME:
		rygel_media_player_set_volume ((RygelMediaPlayer*) self, g_value_get_double (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}




